﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World

	Private ivForeground As B4XView
	Public ivBackground As B4XView
	Private PanelForTouch As B4XView
	Public lblStats As B4XView
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"

	Private Thing As X2BodyWrapper
	

End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, -2))
	X2.Initialize(Me, ivForeground, world)
	Dim WorldHeight As Float = 10 '
	Dim WorldWidth As Float  = WorldHeight * 1.3333
	
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 2, WorldHeight / 2), WorldWidth)
	' MainBC.mWidth / TargetViewWidthInMeters
	
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	
	
	'comment to disable debug drawing
	X2.EnableDebugDraw

	TileMap.Initialize(X2, File.DirAssets, "thing.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldHeight / TileMap.TilesPerColumn, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	

	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		If template.Name <> "hinge" Then 
			Dim bw As X2BodyWrapper = TileMap.CreateObject(template)
			If bw.Name = "thing" Then
				Thing = bw
				'
				Dim PolygonPath As BCPath
				
				Dim polygon As B2PolygonShape =  bw.Body.FirstFixture.Shape
				' Starting Point of Polygone
				Dim PrevVertex As B2Vec2 = bw.body.GetWorldPoint(polygon.GetVertex(0))
				Log("0- " & PrevVertex)
				PrevVertex = X2.WorldPointToMainBC(PrevVertex.X, PrevVertex.Y)
'				PrevVertex.X = X2.MetersToBCPixels(PrevVertex.X)
'				PrevVertex.Y = X2.MetersToBCPixels(PrevVertex.Y)
							
				Log("0+ " & PrevVertex)
				
				PolygonPath.Initialize(PrevVertex.X, PrevVertex.Y)
				' filling path + transfer of World points of shape to BCMain Points
				For i = 1 To polygon.VertexCount 
					Dim vertex As B2Vec2 = bw.body.GetWorldPoint(polygon.GetVertex(i))
					Log(i & "- " & vertex)
					vertex = X2.WorldPointToMainBC(vertex.X, vertex.Y)
					
					PolygonPath.LineTo(vertex.X, vertex.Y)
					PrevVertex = vertex
					Log(i & "+ " & vertex)
				Next
				' close of polygon (the DrawPath do it anyhow)
				PolygonPath.LineTo(PrevVertex.X, PrevVertex.Y)
				'
				Dim size As B2Vec2 = X2.GetShapeWidthAndHeight(template.FixtureDef.Shape)
				Dim rect As B4XRect
				rect.Initialize(0, 0, X2.MetersToBCPixels(size.X), X2.MetersToBCPixels(size.Y))
				Dim bc As BitmapCreator = X2.GraphicCache.GetBitmapCreator(rect.Height)
				'
				' for Garadient filling of the rect
'				bc.FillGradient(Array As Int(Rnd(0xff000000, -1), Rnd(0xff000000, -1)), rect, "TL_BR")
'				Dim Brush As BCBrush = bc.CreateBrushFromBitmapCreator(bc)
				'
'				for the polygon
				Dim Brush As BCBrush = bc.CreateBrushFromColor(xui.Color_Magenta)
				
				bc.DrawPath2(PolygonPath.Clone, Brush, True, 1)
'					
				Dim sb As X2ScaledBitmap
				sb.Scale = 1
				sb.Bmp = bc.Bitmap.Crop(0, 0, rect.Right, rect.Bottom)
					
				X2.GraphicCache.PutGraphic2(template.CustomProps.Get("graphic name"), Array(sb), True,  1)
			End If
		End If
	Next
	

	
	X2.Start
End Sub


Public Sub Tick (GS As X2GameStep)
	'
	If GS.ShouldDraw Then

	End If
	
	
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub



Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = PanelForTouch.TOUCH_ACTION_DOWN Then

	else If Action = PanelForTouch.TOUCH_ACTION_UP Then
		
	End If
End Sub